<template>
  <div class="box p-5 md:p-7 space-y-5">
    <div>
      <label class="text-base font-semibold">Approval Status: </label>
      <Status :status="leaveApplication.approval_status"></Status>
    </div>

    <div v-if="approvingLeave">
      <label class="text-base font-semibold">Applied by: </label>
      <Icon icon="fa-solid fa-user" class="text-sm"></Icon>
      <span class="text-sm">{{ leaveApplication.user.name }} ({{ leaveApplication.user.role.name }})</span>
      <span class="text-sm" v-if="leaveApplication.user.department_staff_detail"> of {{
        leaveApplication.user.department_staff_detail.department.name }} Department</span>
    </div>

    <div>
      <label class="text-base font-semibold">Leave type: </label>
      <sapn class="text-sm">{{ leaveApplication.leave_type.type }}</sapn>
    </div>

    <div>
      <label class="block text-base font-semibold">Leave applied on</label>
      <Icon icon="fa-solid fa-clock" class="text-sm mr-2 text-gray-500"></Icon>
      <span class="text-sm">{{ new Date(leaveApplication.created_at).toLocaleString() }}</span>
    </div>

    <div v-if="leaveApplication.leave_type.balance_type === 'Public Holiday'">
      <label class="block text-base font-semibold">Compensate for these Public Holidays</label>
      <div v-for="ph in leaveApplication.public_holidays" class="text-sm text-gray-500">
        <Icon icon="fa-solid fa-calendar" class="mr-2"></Icon>
        {{ `${ph.name} (${new Date(ph.date).toLocaleString('default', { month: 'long' })} ${new
          Date(ph.date).getDate()})` }}
      </div>
    </div>

    <div class="flex gap-x-10">
      <div>
        <label class="block text-base font-semibold">Start Date</label>
        <Icon icon="fa-solid fa-calendar-days" class="text-sm mr-2 text-gray-500"></Icon>
        <span class="text-sm">{{ leaveApplication.start_date }}</span>
      </div>
      <div>
        <label class="block text-base font-semibold">End Date</label>
        <Icon icon="fa-solid fa-calendar-days" class="text-sm mr-2 text-gray-500"></Icon>
        <span class="text-sm">{{ leaveApplication.end_date }}</span>
      </div>
    </div>

    <div>
      <label class="block text-base font-semibold">Description</label>

      <textarea class="textarea-disabled w-full" :value="leaveApplication.description" disabled>
      </textarea>
    </div>

    <div>
      <label class="block text-base font-semibold">Leave Approvals</label>

      <div v-for="approval in approvals">
        <span class="text-sm mr-2">Stage {{ approval.stage }}:</span>
        <Icon icon="fa-solid fa-user" class="text-sm text-gray-500"></Icon>
        <span class="text-sm" v-if="approval.user">{{ approval.user.name }} ({{ approval.user.role.name
          }})</span>
        <span class="text-sm" v-else>(User not found!)</span>
        <Status :status="approval.status"></Status>
      </div>
      <div class="text-sm" v-if="leaveApplication.approvals.length === 0">
        No Approvers found!
      </div>
    </div>

    <div v-if="approvalWRemarks.length">
      <label class="block text-base font-semibold">Approval Remarks</label>

      <div v-for="approval in approvalWRemarks">
        <textarea class="textarea-disabled w-full" disabled :value="approval.remarks"></textarea>
        <div class="-mt-2 mb-6 flex justify-end">
          <div>
            <Status :status="approval.status"></Status>
            <span class="text-sm" v-if="approval.user"> by {{ approval.user.name }} ({{
              approval.user.role.name
            }})</span>
            <span class="text-sm" v-else>by (User not found!)</span>
            <span class="text-sm mr-2"> on Stage {{ approval.stage }}</span>
          </div>
        </div>
      </div>
    </div>

    <div v-if="approvingLeave">
      <label class="block text-base font-semibold">Do you want to approve or reject this leave?</label>

      <fieldset class="flex text-sm gap-x-10 mt-2">
        <div class="flex items-center gap-x-2">
          <input class="radio" type="radio" value="Approved" v-model="form.status">
          Approve
        </div>

        <div class="flex items-center gap-x-2">
          <input class="radio" type="radio" value="Rejected" v-model="form.status">
          Reject
        </div>
      </fieldset>

      <div v-if="form.errors.status" class="text-error">
        {{ form.errors.status }}
      </div>
    </div>

    <div v-if="approvingLeave">
      <label class="block text-base font-semibold">Write your approval remarks</label>

      <textarea class="textarea mt-2 w-full" placeholder="Leave a remark here" v-model="form.remarks">
      </textarea>
    </div>

    <div v-if="leaveApplication.leave_document && !approvingLeave">
      <a :href="leaveApplication.leave_document.src" class="italic text-sm">
        <Icon icon="fa-solid fa-file" class="text-gray-500 mr-1"></Icon>
        Download Leave Document (last updated at {{ new
          Date(leaveApplication.leave_document.updated_at).toLocaleString() }})
      </a>
    </div>

    <div v-if="(leaveApplication.approvals.map((la) => la.user.id).includes(currentUser.id) || leaveApplication.user.id === currentUser.id) && !approvingLeave">
      <div class="text-base font-semibold mb-2">Document Approvals</div>
      <div v-for="(la, index) in leaveApplication.approvals" class="text-sm">
        <input v-model="docApprovalsForm.doc_approvals[index].approval" type="checkbox" class="checkbox mr-2"
          :disabled="la.user.id !== currentUser.id">
        <span :class="{ 'opacity-30': la.user.id !== currentUser.id }">{{ la.user.name }} ({{ la.user.role.name
          }})</span>
      </div>

      <div class="flex justify-end gap-x-3" v-if="leaveApplication.user.id !== currentUser.id">
        <Link as="button" href="/alert" class="btn orange">
        Cancel
        </Link>
        <button type="button" class="btn green"
          @click="docApprovalsForm.post(`/leave/leaveApplication/${leaveApplication.id}/docApprovals`, { preserveScroll: true })">
          Update Approval
        </button>
      </div>
    </div>

    <div v-if="approvingLeave" class="flex justify-end gap-x-3">
      <Link as="button" href="/leave/leaveRequest" class="btn orange">
      Cancel
      </Link>
      <button type="button" class="btn green"
        @click="form.put(`/leave/leaveRequest/${leaveApplication.id}`, { preserveScroll: true })">
        Save
      </button>
    </div>
    
    <div v-if="leaveApplication.requires_doc && leaveApplication.user.id === currentUser.id && !approvingLeave && (leaveApplication.doc_approvals ? (leaveApplication.doc_approvals.filter((da) => da.approval == false).length > 0) : true)">
      <div class="mb-3">
        <div class="text-base mb-2 font-semibold">Upload/Change Document</div>
        <input @change="(event) => docForm.file = event.target.files[0]" class="w-full input-file" type="file" />
        <div v-if="docForm.errors.file" class="text-error">
          {{ docForm.errors.file }}
        </div>
      </div>
      <div class="flex justify-end gap-x-3">
        <Link as="button" href="/alert" class="btn orange">
        Cancel
        </Link>
        <button type="button" class="btn green"
          @click="docForm.post(`/leave/leaveApplication/${leaveApplication.id}/doc`, { preserveScroll: true })">
          Upload Document
        </button>
      </div>
    </div>
  </div>
</template>

<script setup>
import Status from '@/Components/Status.vue';
import { Link, useForm, usePage } from '@inertiajs/vue3';
import { computed } from 'vue';

const page = usePage();
const currentUser = computed(() => page.props.currentUser)

const props = defineProps({
  leaveApplication: Object,
  approvingLeave: Boolean
});

const approvals = computed(() => props.leaveApplication.approvals.sort((approvalA, approvalB) => approvalA.stage - approvalB.stage))
const approvalWRemarks = computed(() => props.leaveApplication.approvals.sort((approvalA, approvalB) => approvalA.stage - approvalB.stage).filter(approval => approval.status !== 'Pending' && approval.remarks))

const form = useForm({
  status: null,
  remarks: ''
})

const docForm = useForm({
  file: null
})

const docApprovalsForm = useForm({
  doc_approvals: props.leaveApplication.doc_approvals ?? props.leaveApplication.approvals.map((la) => ({ 'user_id': la.user.id, 'approval': false }))
})
</script>